package javaMisc;

/* 
 * CGIPoster.java (C) 1996 Hoa Ton-That 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * this is a general class used to run CGI programs from inside java.  It was
 * hacked together so that I could add high scores and counter ability to
 * my applets.  If anyone has some comments please e-mail me at:
 * hoa@fx.ri.ccf.org
 *
 * There are one methods:
 * String doPost(String name, String data)
 *  name = name of the CGI script you want to run.
 *  data = any parameters you want to pass.
 *  it returns the string that the CGI script replies with, unfortunately I
 *    have yet to figure out how to make java display this string as if
 *    it were a URL file.
 *
 * and a one constructor
 * CGIPoster(Applet app);
 *  app = applet name (needs this to get document base).
 */

import java.net.*;
import java.io.*;
import java.applet.Applet;

public class CGIPoster {
  private final String cType  = "text/html";


  String home;
  int port;

public String doPost(String script, String data) {
  Socket sock;

  InputStream inStream;
  OutputStream outStream;
  DataOutputStream dataOut;
  DataInputStream dataIn;

  String readData = "";

// opening socket
  try {
    sock = new Socket(home, port);
  } catch (Exception e) {
    return(e+" (socket: Host: "+home+"\tPort: "+port+")");
  }


  try {
    outStream = sock.getOutputStream();
    inStream  = sock.getInputStream();
    dataOut = new DataOutputStream(outStream);
    dataIn  = new DataInputStream(inStream);

  } catch (Exception e) {
    readData = e+" (getstream)";
    try {
      sock.close();
    } catch (IOException ee) {}
    return(readData);
  }

// actually send the msg 

  try {
// HTTP header
    dataOut.writeBytes("POST " + script + " HTTP/1.0\n\n");
  
    dataOut.writeBytes("Content-type: " + cType + "\n\n");
    dataOut.writeBytes("Content-length: " + data.length() + "\n\n");
    dataOut.writeBytes("\n\n");

    dataOut.writeBytes(data);
    boolean hasData = false;

    String line;
    while ((line = dataIn.readLine()) != null) {
      if (hasData)
        readData += "\n" + line;
      else if("".equals(line)) 
        hasData = true;
    }
  } catch (Exception e) {
    readData = e+" (write)";
    try {
      sock.close();
    } catch (IOException ee) {}
    return(readData);
  }

  try {
    dataOut.close();
    dataIn.close();
  } catch (IOException e) {}
  try {
    sock.close();
  } catch (IOException e) {}
  return(readData);
}

public CGIPoster(Applet app) {
  home = app.getDocumentBase().getHost();
  port = app.getDocumentBase().getPort();
  if(port == -1)
    port = 80;
}
}
