From alberta!rover.ucs.ualberta.ca!news.bc.net!news.mindlink.net!uniserve!news.sol.net!daily-planet.execpc.com!usenet Fri Feb  2 21:54:05 1996
Path: alberta!rover.ucs.ualberta.ca!news.bc.net!news.mindlink.net!uniserve!news.sol.net!daily-planet.execpc.com!usenet
From: bitsafe@execpc.com (bitsafe)
Newsgroups: comp.lang.java
Subject: Here is the source code for an editor I wrote
Date: Fri, 02 Feb 1996 18:07:51 GMT
Organization: Exec-PC BBS - Milwaukee, WI
Lines: 829
Message-ID: <4etjpo$1du@daily-planet.execpc.com>
NNTP-Posting-Host: mayfly.execpc.com
X-Newsreader: Forte Free Agent 1.0.82

// Tred - TRivial EDitor - written by Larry Landwehr
(bitsafe@execpc.com)
// Usage: "java Tred" or "java Tred filename"
// Copyright 1996 by Larry Landwehr

import java.awt.*;
import java.io.*;

//______________________________________________________________
//______________________________________________________________
public class Tred extends Frame {

    TextArea textArea;
    ButtonPanel buttonPanel;
    String findString = "";
    String copyString = "";
    String replaceString = "";
    private String fileName = null;
    private FileDialog openDialog, saveDialog;
    private MenuItem newMenuItem, openMenuItem;
    private MenuItem helpMenuItem, aboutMenuItem;
    private MenuItem saveMenuItem, saveAsMenuItem, exitMenuItem;
    private MenuItem findMenuItem, findPopMenuItem;
    private MenuItem deleteMenuItem, replaceMenuItem;
    private MenuItem replacePopMenuItem, replaceAllMenuItem;
    private MenuItem copyMenuItem,pasteMenuItem;
    private CheckboxMenuItem buttonsMenuItem;
    private HelpDialog helpDialog = null;
    private AboutDialog aboutDialog = null;
    private ReplaceDialog replaceDialog = null;
    private FindDialog findDialog = null;
    private ErrorDialog errorDialog = null;

    public Tred() {

        super("Tred (TRivial EDitor) - written by Larry Landwehr " +
            "(bitsafe@execpc.com) - Copyright 1996");

        setBackground(Color.gray);
        setFont(new Font("TimesRoman", Font.PLAIN, 12));

        CreateMenus();
        CreateTextArea();
        CreateButtonPanel();
        CreateDialogs();

        Dimension d;
        d = Toolkit.getDefaultToolkit().getScreenSize();
        resize(d.width, d.height);

        show();
        textArea.requestFocus();
    }

    private void CreateMenus() {

        Menu menu;
        MenuBar menuBar = new MenuBar();

        // File menu
        menu = new Menu("File");
        newMenuItem = new MenuItem("New");
        menu.add(newMenuItem);
        openMenuItem = new MenuItem("Open");
        menu.add(openMenuItem);
        saveMenuItem = new MenuItem("Save (F9)");
        menu.add(saveMenuItem);
        saveAsMenuItem = new MenuItem("Save As");
        menu.add(saveAsMenuItem);
        menu.addSeparator();
        buttonsMenuItem = new CheckboxMenuItem("Show Buttons");
        buttonsMenuItem.setState(true);
        menu.add(buttonsMenuItem);
        menu.addSeparator();
        exitMenuItem = new MenuItem("Exit");
        menu.add(exitMenuItem);
        menuBar.add(menu);

        // Search menu
        menu = new Menu("Search");
        findMenuItem = new MenuItem("Find  (F2)");
        menu.add(findMenuItem);
        findPopMenuItem = new MenuItem("FindPop  (F3)");
        menu.add(findPopMenuItem);
        menuBar.add(menu);

        // Edit menu
        menu = new Menu("Edit");
        deleteMenuItem = new MenuItem("Delete  (F4)");
        menu.add(deleteMenuItem);
        replaceMenuItem = new MenuItem("Replace  (F5)");
        menu.add(replaceMenuItem);
        replacePopMenuItem = new MenuItem("ReplacePop  (F6)");
        menu.add(replacePopMenuItem);
        replaceAllMenuItem = new MenuItem("ReplaceAll  (F7)");
        menu.add(replaceAllMenuItem);
        copyMenuItem = new MenuItem("Copy");
        menu.add(copyMenuItem);
        pasteMenuItem = new MenuItem("Paste");
        menu.add(pasteMenuItem);
        menuBar.add(menu);

        // Help menu
        menu = new Menu("Help");
        helpMenuItem = new MenuItem("Help");
        menu.add(helpMenuItem);
        menu.addSeparator();
        aboutMenuItem = new MenuItem("About");
        menu.add(aboutMenuItem);
        menuBar.add(menu);

        setMenuBar(menuBar);
    }

    private void CreateTextArea() {
        textArea = new TextArea(24, 80);
        textArea.setEditable(true);
        add("Center", textArea);
    }

    private void CreateButtonPanel() {
        buttonPanel = new ButtonPanel(this);
        add("South", buttonPanel);
    }

    private void CreateDialogs() {
        openDialog = new FileDialog(this, "Open File",
FileDialog.LOAD);
        saveDialog = new FileDialog(this, "Save File",
FileDialog.SAVE);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                System.exit(0);
            case Event.ACTION_EVENT:
                if(evt.target instanceof MenuItem) {
                    if(evt.target == openMenuItem) openFile();
                    else if(evt.target == saveAsMenuItem)
saveAsFile();
                    else if(evt.target == aboutMenuItem)
showAboutDialog();
                    else if(evt.target == newMenuItem) startNewText();
                    else if(evt.target == saveMenuItem)
saveOpenedFile();
                    else if(evt.target == exitMenuItem)
System.exit(0);
                    else if(evt.target == helpMenuItem)
showHelpDialog();
                    else if(evt.target == findMenuItem)
findSelectedText();
                    else if(evt.target == findPopMenuItem)
showFindDialog();
                    else if(evt.target == deleteMenuItem)
deleteText();
                    else if(evt.target == replaceMenuItem)
replaceSelectText();
                    else if(evt.target == replacePopMenuItem)
showRepDialog();
                    else if(evt.target == replaceAllMenuItem)
replaceAll();
                    else if(evt.target == buttonsMenuItem)
showButtons();
                    else if(evt.target == copyMenuItem) copy();
                    else if(evt.target == pasteMenuItem) paste();
                    else if(evt.target == buttonsMenuItem)
showButtons();
                    else System.out.println("Internal program error
#1!");
                }
                return(true);
            case Event.KEY_ACTION:
                if (evt.key == Event.F2) findSelectedText();
                else if (evt.key == Event.F3) showFindDialog();
                else if (evt.key == Event.F4) deleteText();
                else if (evt.key == Event.F5) replaceSelectText();
                else if (evt.key == Event.F6) showRepDialog();
                else if (evt.key == Event.F7) replaceAll();
                else if (evt.key == Event.F9) saveOpenedFile();
        }
        return(false);
    }

    public void copy() {
        copyString = textArea.getSelectedText();
        textArea.requestFocus();
    }

    public void paste() {
        if (copyString.length() > 0)
            textArea.insertText(copyString,
textArea.getSelectionStart());
        textArea.requestFocus();
    }

    private void showButtons() {
        Dimension d1 = textArea.size();
        Dimension d2 = buttonPanel.size();
        if (buttonsMenuItem.getState()) {
            textArea.resize(d1.width-d2.width, d1.height-d2.height);
            buttonPanel.show();
        } else {
            buttonPanel.hide();
            textArea.resize(d1.width+d2.width, d1.height+d2.height);
        }
    }

    // Read in an existing file
    private void openFile() {
        String filename;
        openDialog.show();
        filename = openDialog.getFile();
        if (filename != null) {
            filename = check(filename);
            if (read(filename)) fileName = filename;
        }
        textArea.requestFocus();
    }

    // Save text to new or existing file
    private void saveAsFile() {
        String filename;
        saveDialog.show();
        filename = saveDialog.getFile();
        if (filename != null) {
            filename = check(filename);
            if (write(filename)) fileName = filename;
        }
        textArea.requestFocus();
    }

    // Save text to already opened file
    public void saveOpenedFile() {
        if (fileName == null) {
            showErrorDialog("You must specify a filename");
        } else {
            write(fileName);
            textArea.requestFocus();
        }
    }

    private void startNewText() {
        fileName = null;
        textArea.setText("");
        textArea.requestFocus();
    }

    private void showAboutDialog() {
        if (aboutDialog != null) aboutDialog.dispose();
        aboutDialog = new AboutDialog(this);
        aboutDialog.show();
    }

    private void showHelpDialog() {
        if (helpDialog != null) helpDialog.dispose();
        helpDialog = new HelpDialog(this);
        helpDialog.show();
    }

    public void showFindDialog() {
        if (findDialog != null) findDialog.dispose();
        String sel = textArea.getSelectedText();
        if (sel.length() > 0) findString = sel;
        findDialog = new FindDialog(this, findString);
        findDialog.show();
        findDialog.setFocus();
    }

    public void showRepDialog() {
        if (replaceDialog != null) replaceDialog.dispose();
        String sel = textArea.getSelectedText();
        if (sel.length() > 0) findString = sel;
        replaceDialog = new ReplaceDialog(this, findString,
replaceString);
        replaceDialog.show();
        replaceDialog.setFocus();
    }

    public void showErrorDialog(String message) {
        if (errorDialog != null) errorDialog.dispose();
        errorDialog = new ErrorDialog(this, message);
        errorDialog.show();
    }

    private boolean read(String filename) {

        String line;
        FileInputStream in = null;
        DataInputStream dataIn = null;
        BufferedInputStream bis = null;
        StringBuffer buffer = new StringBuffer();

        try {
            in = new FileInputStream(filename);
            bis = new BufferedInputStream(in);
            dataIn = new DataInputStream(bis);
        } catch(Throwable e) {
            showErrorDialog("Can't open \""+filename+"\"");
            return(false);
        }

        try {
            while ((line = dataIn.readLine()) != null) {
                buffer.append(line + "\n");
            }
            in.close();
            textArea.setText(buffer.toString());
        } catch(IOException e) {
            showErrorDialog("Can't read \""+filename+"\"");
            return(false);
        }

        return(true);
    }

    private boolean write(String filename) {

        FileOutputStream os = null;

        try {
            os = new FileOutputStream(filename);
        } catch (Throwable e) {
            showErrorDialog("Can't open \""+filename+"\"");
            return(false);
        }

        try {
            String s = textArea.getText();
            int len = s.length();
            for (int i=0; i<len; i++) {
               os.write(s.charAt(i));
            }
            os.close();
        } catch(IOException e) {
            showErrorDialog("Can't write \""+filename+"\"");
            return(false);
        }

        return(true);
    }

    // Compensate for dialog bug
    private String check(String filename) {
        if (filename.endsWith(".*.*")) {
            filename = filename.substring(0, filename.length()-4);
        }
        return(filename);
    }

    public void setFindString(String str) {
        findString = str;
    }

    public void setReplaceString(String str) {
        replaceString = str;
    }

    public void findSelectedText() {
        String sel = textArea.getSelectedText();
        if (sel.length() > 0) findString = sel;
        findText();
    }

    public void findText() {

        String s;
        int spoint, index;

        textArea.requestFocus();
        if (findString.length() == 0) return;

        s = textArea.getText();
        if (s.length() == 0) return;

        spoint = textArea.getSelectionEnd();
        index = s.substring(spoint).indexOf(findString);
        if (index >= 0) {
            int i = spoint + index;
            textArea.select(i, i + findString.length());
        }
    }

    public void replaceSelectText() {
        String sel = textArea.getSelectedText();
        if (sel.length() > 0) findString = sel;
        replaceText();
    }

    public boolean replaceText() {
        String s;
        int spoint, index;

        textArea.requestFocus();
        if (findString.length() == 0) return(false);

        s = textArea.getText();
        if (s.length() == 0) return(false);

        spoint = textArea.getSelectionEnd();
        index = s.substring(spoint).indexOf(findString);
        if (index >= 0) {
            int i = spoint + index;
            int j = i + findString.length();
            textArea.replaceText(replaceString, i, j);
            textArea.select(i, i+replaceString.length());
            return(true);
        }
        return(false);
    }

    public void replaceAll() {
        String sel = textArea.getSelectedText();
        if (sel.length() > 0) findString = sel;
        textArea.select(0, 0);
        while (replaceText()) ;
    }

    public void deleteText() {
        textArea.replaceText("", textArea.getSelectionStart(),
            textArea.getSelectionEnd());
        textArea.requestFocus();
    }

    // Where execution begins in a stand-alone executable
    public static void main(String args[]) {
        Tred n = new Tred();
        if (args.length == 1)
            if (n.read(args[0])) n.fileName = args[0];
    }
}

//______________________________________________________________
//______________________________________________________________
class HelpDialog extends Dialog {

    Tred parent;

    public HelpDialog(Tred parent) {
        super(parent, "Help Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Dimension d;
        d = parent.size();
        int WIDTH = 500;
        int HEIGHT = 200;
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,
HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                parent.textArea.requestFocus();
                return(true);
        }
        return(false);
    }

    public void paint(Graphics g) {
        Dimension d;
        d = size();

        g.setColor(Color.black);
        int x[] = new int[50];
        int y[] = new int[50];
        for (int i=0; i<49; i++) {
            x[i] = (int)((d.width-20) * Math.random() + 10);
            y[i] = (int)((d.height-20) * Math.random() + 10);
        }
        x[49] = x[0];
        y[49] = y[0];
        Polygon p = new Polygon(x, y, 50);
        g.fillPolygon(p);

        g.setColor(Color.yellow);
        g.setFont(new Font("TimesRoman", Font.PLAIN, 25));
        g.drawString("Hold down the shift key while using", 10,
d.height/5);
        g.drawString("the arrow keys to select text.", 10,
2*d.height/5);
        g.drawString("PS: Try selecting help again.", 10,
4*d.height/5);
    }
}

//______________________________________________________________
//______________________________________________________________
class AboutDialog extends Dialog {

    Tred parent;

    public AboutDialog(Tred parent) {

        super(parent, "About Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        p = new Panel();
        p.setBackground(Color.black);
        add("North", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("South", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("East", p);
        p = new Panel();
        p.setBackground(Color.black);
        add("West", p);

        p = new Panel();
        p.setLayout(new GridLayout(7, 1));
        p.add(new Label(""));
        p.add(new Label("Trivial Editor (Tred)"));
        p.add(new Label("An editor written in the Java language"));
        p.add(new Label("Copyright 1996 by Larry Landwehr " +
            "(bitsafe@execpc.com)"));
        p.add(new Label(""));
        p.add(new Label("This program took about 30 hours to write"));
        p.add(new Label(""));
        add("Center", p);

        Dimension d;
        d = parent.size();
        int WIDTH = 400;
        int HEIGHT = 200;
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,
HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                parent.textArea.requestFocus();
                return(true);
        }
        return(false);
    }
}

//______________________________________________________________
//______________________________________________________________
class FindDialog extends Dialog {

    Tred parent;
    TextField textField;

    public FindDialog(Tred parent, String text) {

        super(parent, "Find Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        Label l;
        int WIDTH = 300;
        int HEIGHT = 75;

        p = new Panel();
        p.setLayout(null);

        int height = 25, space = 10;
        int lwidth = 35, rmargin = 30;
        int y = HEIGHT / 2 - height;

        l = new Label("Find");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        textField = new TextField(text);
        int f = lwidth + space;
        textField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(textField);

        add("Center", p);

        Dimension d;
        d = parent.size();
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,
HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                parent.textArea.requestFocus();
                return(true);
            case Event.ACTION_EVENT:
                if(evt.target == textField) {
                    dispose();
                    if (textField.getText().length() > 0) {
                        parent.setFindString(textField.getText());
                        parent.findText();
                        parent.textArea.requestFocus();
                        return(true);
                    }
                } else {
                    System.out.println("Internal program error #4!");
                    parent.textArea.requestFocus();
                    return(true);
                }
        }
        return(false);
    }

    public void setFocus() {
        textField.requestFocus();
        textField.select(0, textField.getText().length());
    }
}

//______________________________________________________________
//______________________________________________________________
class ReplaceDialog extends Dialog {

    Tred parent;
    TextField fromField, toField;

    public ReplaceDialog(Tred parent, String fromString, String
toString) {

        super(parent, "Replace Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;

        Panel p;
        Label l;
        int WIDTH = 300;
        int HEIGHT = 100;

        p = new Panel();
        p.setLayout(null);

        int height = 25, space = 10;
        int lwidth = 50, rmargin = 30;
        int y = HEIGHT / 3 - height;

        l = new Label("Replace");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        fromField = new TextField(fromString);
        int f = lwidth + space;
        fromField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(fromField);

        y = 2 * HEIGHT / 3 - height;

        l = new Label("With");
        l.reshape(0, y, lwidth, height);
        p.add(l);

        toField = new TextField(toString);
        f = lwidth + space;
        toField.reshape(f, y, WIDTH-f-rmargin, height);
        p.add(toField);

        add("Center", p);

        Dimension d;
        d = parent.size();
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,
HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                parent.textArea.requestFocus();
                return(true);
            case Event.ACTION_EVENT:
                if(evt.target == fromField) {
                    toField.requestFocus();
                    return(true);
                } else if(evt.target == toField) {
                    dispose();
                    if (fromField.getText().length() > 0) {
                        parent.setFindString(fromField.getText());
                        parent.setReplaceString(toField.getText());
                        parent.replaceText();
                        parent.textArea.requestFocus();
                        return(true);
                    }
                } else {
                    System.out.println("Internal program error #5!");
                    parent.textArea.requestFocus();
                    return(true);
                }
        }
        return(false);
    }

    public void setFocus() {
        fromField.requestFocus();
        fromField.select(0, fromField.getText().length());
    }
}

//______________________________________________________________
//______________________________________________________________
class ButtonPanel extends Panel {

    Tred parent;
    Button button[] = new Button[20];

    public ButtonPanel(Tred parent) {
        super();
        setLayout(new GridLayout(1, 0));
        setFont(new Font("TimesRoman", Font.PLAIN, 10));
        this.parent = parent;

        int i = 0;
        button[i] = new Button("Find");
        add(button[i++]);
        button[i] = new Button("FindPop");
        add(button[i++]);
        button[i] = new Button("Delete");
        add(button[i++]);
        button[i] = new Button("Replace");
        add(button[i++]);
        button[i] = new Button("ReplacePop");
        add(button[i++]);
        button[i] = new Button("ReplaceAll");
        add(button[i++]);
        button[i] = new Button("Copy");
        add(button[i++]);
        button[i] = new Button("Paste");
        add(button[i++]);
        button[i] = new Button("Save");
        add(button[i++]);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.ACTION_EVENT:
                if(evt.target == button[0]) parent.findSelectedText();
                else if(evt.target == button[1])
parent.showFindDialog();
                else if(evt.target == button[2]) parent.deleteText();
                else if(evt.target == button[3])
parent.replaceSelectText();
                else if(evt.target == button[4])
parent.showRepDialog();
                else if(evt.target == button[5]) parent.replaceAll();
                else if(evt.target == button[6]) parent.copy();
                else if(evt.target == button[7]) parent.paste();
                else if(evt.target == button[8])
parent.saveOpenedFile();
                else System.out.println("Internal program error #6!");
                return(true);
        }
        return(false);
    }
}

//______________________________________________________________
//______________________________________________________________
class ErrorDialog extends Dialog {

    Tred parent;
    String message;

    public ErrorDialog(Tred parent, String message) {
        super(parent, "Error Dialog", true);
        setBackground(Color.lightGray);
        this.parent = parent;
        this.message = message;

        Dimension d;
        d = parent.size();
        int WIDTH = 500;
        int HEIGHT = 130;
        reshape((d.width-WIDTH)/2, (d.height-HEIGHT)/3, WIDTH,
HEIGHT);
        setResizable(false);
    }

    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY:
                dispose();
                parent.textArea.requestFocus();
                return(true);
        }
        return(false);
    }

    public void paint(Graphics g) {
        Dimension d;
        d = size();

        g.setColor(Color.yellow);
        int x[] = new int[4];
        int y[] = new int[4];
        x[0] = 10; y[0] = 10;
        x[1] = d.width/3; y[1] = 3*d.height/4;
        x[2] = d.width-10; y[2] = 10;
        x[3] = 10; y[3] = 10;
        Polygon p = new Polygon(x, y, 4);
        g.fillPolygon(p);

        g.setColor(Color.black);
        g.setFont(new Font("TimesRoman", Font.PLAIN, 25));
        g.drawString(message, 10, d.height/2);
    }
}


IZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZI
I
I  BitSafe Computer Services
I  Optical Character Recognition via the Internet
I  Don't retype it, let us scan it!
I  http://www.execpc.com/~bitsafe
I  bitsafe@execpc.com
I
IZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZI


