import java.awt.* ;
import java.util.* ;

/**
Author Jean-Claude Dufourd
Version 1
Date 29.11.95
Title XyLayout 
*/

public class XyLayout implements LayoutManager {

    Dimension d;
    Vector components = new Vector(10,10);
    Vector constraints = new Vector(10,10);

    /* RelativeLayout has a fixed size */
    public XyLayout(Dimension dim) {
	d = dim;
    }

    public void addLayoutComponent(String name, Component comp) {
	components.addElement( comp );
	constraints.addElement( null );
    }

    public void removeLayoutComponent(Component comp) {
	int i = components.indexOf( comp );
	if (i != -1) {
	    components.removeElementAt( i );
	    constraints.removeElementAt( i );
	}
    }

    public Dimension minimumLayoutSize(Container target) {
	return d;
    }
    
    public Dimension preferredLayoutSize(Container target) {
	return d;
    }

    public void setConstraint( Component self, int dx, int dy ) {
	int i = components.indexOf( self );
	// ignore unknown components
	if (i != -1) {
	    Dimension c = new Dimension( dx, dy );
	    constraints.setElementAt( c, i );
	}
    }

    public void layoutContainer(Container target) {
	Enumeration e = components.elements();
	Rectangle oneBounds, referenceBounds;
	Dimension constr;
	Dimension d;
	Component c;
	int i = -1;
	while (e.hasMoreElements()) {
	    i = i + 1;
	    constr = (Dimension)constraints.elementAt( i );
	    c = (Component)e.nextElement();
	    d = c.preferredSize();
	    oneBounds = c.bounds();
	    referenceBounds = target.bounds();
	    c.reshape( referenceBounds.x + constr.width,
		      referenceBounds.y + constr.height,
		      d.width, d.height ); 
	}
    }
}


